<?php

namespace Drupal\better_json_response\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Configuration form for better json response.
 */
class BetterJsonResponseConfigForm extends ConfigFormBase {

  public const FORM_ID = 'better_json_reponse_config_form';
  public const CONFIG_NAME = 'better_json_reponse.settings';

  /**
   * {@inheritDoc}
   */
  protected function getEditableConfigNames(): array {
    return [static::CONFIG_NAME];
  }

  /**
   * {@inheritDoc}
   */
  public function getFormId(): string {
    return static::FORM_ID;
  }

  /**
   * {@inheritDoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $form['deactivate_cache'] = [
      '#type' => 'checkbox',
      '#title' => $this->t('Deactivate cache'),
      '#default_value' => $this->config(static::CONFIG_NAME)->get('deactivate_cache'),
      '#description' => $this->t('Deactivate cache for all responses that use BetterJsonResponse class.'),
    ];
    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritDoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state): void {
    $config = $this->configFactory()->getEditable(static::CONFIG_NAME);
    $config->set('deactivate_cache', $form_state->getValue('deactivate_cache'));
    $config->save();
    parent::submitForm($form, $form_state);
  }

}
